## benchmark 0.3

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3
Date: 2010-06-14
Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Depends: utils, proto, ggplot2, reshape, relations
Suggests: coin, multcomp, lme4, e1071, entropy
Description: The benchmark package provides a toolbox for setup,
        execution and analysis of benchmark experiments. Main focus is
        the analysis of data accumulating during the execution -- one
        primary objective is the statistical correct computation of the
        candidate algorithms' order.
License: GPL (>= 2)
Revision: 45
LazyLoad: false
LazyData: true
Collate: 'algperf-beplot0.R' 'test.R' 'proto.R' 'algperf-paircomp.R'
        'algperf-preference.R' 'algperf-visualizations.R' 'warehouse.R'
        'algperf.R' 'as.warehouse.R' 'benchmark.R'
        'datachar-visualizations.R' 'dataset-characteristics.R'
        'dataset.R' 'dataset-characterization.R' 'testres-analysis.R'
        'testres-visualizations.R'
Packaged: 2010-06-19 13:10:53 UTC; manuel
Repository: CRAN
Date/Publication: 2010-06-19 16:45:52

## benchmark 0.3-1

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3-1
Date: 2010-08-06
Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Depends: utils, proto, ggplot2, reshape, relations
Suggests: coin, multcomp, lme4, e1071, entropy
Description: The benchmark package provides a toolbox for setup,
        execution and analysis of benchmark experiments. Main focus is
        the analysis of data accumulating during the execution -- one
        primary objective is the statistical correct computation of the
        candidate algorithms' order.
License: GPL (>= 2)
Revision: 51
LazyLoad: false
LazyData: true
Collate: 'algperf-beplot0.R' 'testprocedure.R' 'proto.R'
        'algperf-paircomp.R' 'algperf-preference.R'
        'algperf-visualizations.R' 'warehouse.R' 'algperf.R'
        'as.warehouse.R' 'benchmark.R' 'datachar-visualizations.R'
        'dataset-characteristics.R' 'dataset.R'
        'dataset-characterization.R' 'testres-analysis.R'
        'testres-visualizations.R'
Packaged: 2010-08-06 12:11:55 UTC; meugster
Repository: CRAN
Date/Publication: 2010-08-06 12:45:08

## benchmark 0.3-2

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3-2
Date: 2011-02-09
Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Depends: utils, proto, ggplot2, reshape, relations
Suggests: coin, multcomp, lme4, e1071, entropy, archetypes, Rgraphviz
Description: The benchmark package provides a toolbox for setup,
        execution and analysis of benchmark experiments. Main focus is
        the analysis of data accumulating during the execution -- one
        primary objective is the statistical correct computation of the
        candidate algorithms' order.
License: GPL (>= 2)
Revision: 59
LazyLoad: false
LazyData: true
Collate: 'algperf-beplot0.R' 'testprocedure.R' 'proto.R'
        'algperf-paircomp.R' 'algperf-preference.R'
        'algperf-visualizations.R' 'warehouse.R' 'algperf.R'
        'as.warehouse.R' 'benchmark.R' 'bsgraph.R' 'bsplot.R'
        'datachar-visualizations.R' 'dataset-characteristics.R'
        'dataset.R' 'dataset-characterization.R' 'testres-analysis.R'
        'testres-visualizations.R'
Packaged: 2011-02-09 15:29:57 UTC; vadmin
Repository: CRAN
Date/Publication: 2011-02-10 06:52:54

## benchmark 0.3-3

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3-3
Date: 2012-01-30
Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Depends: R (>= 2.10), utils, proto, ggplot2, reshape, relations
Suggests: coin, multcomp, lme4, e1071, entropy, archetypes, Rgraphviz
Description: The benchmark package provides a toolbox for setup,
        execution and analysis of benchmark experiments. Main focus is
        the analysis of data accumulating during the execution -- one
        primary objective is the statistical correct computation of the
        candidate algorithms' order.
License: GPL (>= 2)
Revision: 59
LazyLoad: false
LazyData: true
URL: http://benchmark.r-forge.r-project.org/
Packaged: 2012-01-30 10:40:13 UTC; vadmin
Repository: CRAN
Date/Publication: 2012-01-30 12:13:00

## benchmark 0.3-4

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3-4
Date: 2012-03-15
Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
Depends: R (>= 2.10), utils, proto, ggplot2, reshape, relations,
        psychotools
Imports: scales
Suggests: coin, multcomp, lme4, e1071, entropy, archetypes, Rgraphviz,
        psychotree
Description: The benchmark package provides a toolbox for setup,
        execution and analysis of benchmark experiments. Main focus is
        the analysis of data accumulating during the execution -- one
        primary objective is the statistical correct computation of the
        candidate algorithms' order.
License: GPL (>= 2)
URL: http://benchmark.r-forge.r-project.org/
Collate: 'algperf-beplot0.R' 'testprocedure.R' 'proto.R'
        'algperf-paircomp.R' 'algperf-preference.R'
        'algperf-visualizations.R' 'warehouse.R' 'algperf.R'
        'as.psychobench.R' 'as.warehouse.R' 'benchmark.R' 'bsgraph.R'
        'bsplot.R' 'datachar-visualizations.R'
        'dataset-characteristics.R' 'dataset.R'
        'dataset-characterization.R' 'testres-analysis.R'
        'testres-visualizations.R'
Packaged: 2012-03-16 08:28:24 UTC; meugster
Repository: CRAN
Date/Publication: 2012-03-16 08:53:45

## benchmark 0.3-5

=== DESCRIPTION ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Package: benchmark
 Type: Package
 Title: Benchmark Experiments Toolbox
-Version: 0.3-4
-Date: 2012-03-15
-Author: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
-Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
+Version: 0.3-5
+Date: 2012-12-03
+Authors@R: c(person("Manuel", "J. A. Eugster", role = c("aut", "cre"),
+        email = "manuel.eugster@stat.uni-muenchen.de"))
 Depends: R (>= 2.10), utils, proto, ggplot2, reshape, relations,
-        psychotools
-Imports: scales
+        psychotools, scales
 Suggests: coin, multcomp, lme4, e1071, entropy, archetypes, Rgraphviz,
         psychotree
 Description: The benchmark package provides a toolbox for setup,
@@ -25,6 +24,8 @@
         'dataset-characteristics.R' 'dataset.R'
         'dataset-characterization.R' 'testres-analysis.R'
         'testres-visualizations.R'
-Packaged: 2012-03-16 08:28:24 UTC; meugster
+Packaged: 2012-12-03 10:46:36 UTC; eugstem1
+Author: Manuel J. A. Eugster [aut, cre]
+Maintainer: Manuel J. A. Eugster <manuel.eugster@stat.uni-muenchen.de>
 Repository: CRAN
-Date/Publication: 2012-03-16 08:53:45
+Date/Publication: 2012-12-03 12:08:07

## benchmark 0.3-6

=== DESCRIPTION ===
Package: benchmark
Type: Package
Title: Benchmark Experiments Toolbox
Version: 0.3-6
Date: 2014-05-02
Authors@R: c(person("Manuel", "J. A. Eugster", role = c("aut", "cre"),
    email = "manuel@mjae.net"))
Depends: R (>= 2.10), utils, proto, ggplot2, relations, psychotools
Imports: reshape, scales, plyr
Suggests: coin, multcomp, lme4, e1071, entropy, archetypes, Rgraphviz,
        psychotree
Description: The benchmark package provides a toolbox for setup, execution
    and analysis of benchmark experiments. Main focus is the analysis of
    data accumulating during the execution -- one primary objective is the
    statistical correct computation of the candidate algorithms' order.
License: GPL (>= 2)
URL: http://benchmark.r-forge.r-project.org/
Collate: 'algperf-beplot0.R' 'testprocedure.R' 'proto.R'
        'algperf-paircomp.R' 'algperf-preference.R'
        'algperf-visualizations.R' 'warehouse.R' 'algperf.R'
        'as.psychobench.R' 'as.warehouse.R' 'benchmark.R' 'bsgraph.R'
        'bsplot.R' 'datachar-visualizations.R'
        'dataset-characteristics.R' 'dataset.R'
        'dataset-characterization.R' 'testres-analysis.R'
        'testres-visualizations.R'
Packaged: 2014-05-02 19:33:37 UTC; eugstem1
Author: Manuel J. A. Eugster [aut, cre]
Maintainer: Manuel J. A. Eugster <manuel@mjae.net>
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2014-05-02 21:48:47

## benchmark 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

project (benchmark)

foreach(p
    CMP0054 # CMake 3.1
    CMP0056 # export EXE_LINKER_FLAGS to try_run
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

option(BENCHMARK_ENABLE_TESTING "Enable testing of the benchmark library." ON)
option(BENCHMARK_ENABLE_EXCEPTIONS "Enable the use of exceptions in the benchmark library." ON)
option(BENCHMARK_ENABLE_LTO "Enable link time optimisation of the benchmark library." OFF)
option(BENCHMARK_USE_LIBCXX "Build and test using libc++ as the standard library." OFF)
option(BENCHMARK_BUILD_32_BITS "Build a 32 bit version of the library." OFF)
option(BENCHMARK_ENABLE_INSTALL "Enable installation of benchmark. (Projects embedding benchmark may want to turn this OFF.)" ON)

# Make sure we can import out CMake functions
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Read the git tags to determine the project version
include(GetGitVersion)
get_git_version(GIT_VERSION)

# Tell the user what versions we are using
string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" VERSION ${GIT_VERSION})
message("-- Version: ${VERSION}")

# The version of the libraries
set(GENERIC_LIB_VERSION ${VERSION})
string(SUBSTRING ${VERSION} 0 1 GENERIC_LIB_SOVERSION)

# Import our CMake modules
include(CheckCXXCompilerFlag)
include(AddCXXCompilerFlag)
include(CXXFeatureCheck)

if (BENCHMARK_BUILD_32_BITS)
  add_required_cxx_compiler_flag(-m32)
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  # Turn compiler warnings up to 11
  string(REGEX REPLACE "[-/]W[1-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)

  if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
    add_cxx_compiler_flag(-EHs-)
    add_cxx_compiler_flag(-EHa-)
  endif()
  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /GL")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")

    set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL "${CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /LTCG")
  endif()
else()
  # Try and enable C++11. Don't use C++14 because it doesn't work in some
  # configurations.
  add_cxx_compiler_flag(-std=c++11)
  if (NOT HAVE_CXX_FLAG_STD_CXX11)
    add_cxx_compiler_flag(-std=c++0x)
  endif()

  # Turn compiler warnings up to 11
  add_cxx_compiler_flag(-Wall)

  add_cxx_compiler_flag(-Wextra)
  add_cxx_compiler_flag(-Wshadow)
  add_cxx_compiler_flag(-Werror RELEASE)
  add_cxx_compiler_flag(-Werror RELWITHDEBINFO)
  add_cxx_compiler_flag(-Werror MINSIZEREL)
  add_cxx_compiler_flag(-pedantic)
  add_cxx_compiler_flag(-pedantic-errors)
  add_cxx_compiler_flag(-Wshorten-64-to-32)
  add_cxx_compiler_flag(-Wfloat-equal)
  add_cxx_compiler_flag(-fstrict-aliasing)
  if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
    add_cxx_compiler_flag(-fno-exceptions)
  endif()
  if (NOT BENCHMARK_USE_LIBCXX)
    add_cxx_compiler_flag(-Wzero-as-null-pointer-constant)
  endif()
  if (HAVE_CXX_FLAG_FSTRICT_ALIASING)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel") #ICC17u2: Many false positives for Wstrict-aliasing
      add_cxx_compiler_flag(-Wstrict-aliasing)
    endif()
  endif()
  # ICC17u2: overloaded virtual function "benchmark::Fixture::SetUp" is only partially overridden
  # (because of deprecated overload)
  add_cxx_compiler_flag(-wd654)  
  add_cxx_compiler_flag(-Wthread-safety)
  if (HAVE_CXX_FLAG_WTHREAD_SAFETY)
    cxx_feature_check(THREAD_SAFETY_ATTRIBUTES)
  endif()

  # On most UNIX like platforms g++ and clang++ define _GNU_SOURCE as a
  # predefined macro, which turns on all of the wonderful libc extensions.
  # However g++ doesn't do this in Cygwin so we have to define it ourselfs
  # since we depend on GNU/POSIX/BSD extensions.
  if (CYGWIN)
    add_definitions(-D_GNU_SOURCE=1)
  endif()

  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    add_cxx_compiler_flag(-flto)
    if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
      find_program(GCC_AR gcc-ar)
      if (GCC_AR)
        set(CMAKE_AR ${GCC_AR})
      endif()
      find_program(GCC_RANLIB gcc-ranlib)
      if (GCC_RANLIB)
        set(CMAKE_RANLIB ${GCC_RANLIB})
      endif()
    endif()
  endif()

  # Coverage build type
  set(BENCHMARK_CXX_FLAGS_COVERAGE "${CMAKE_CXX_FLAGS_DEBUG}"
    CACHE STRING "Flags used by the C++ compiler during coverage builds."
    FORCE)
  set(BENCHMARK_EXE_LINKER_FLAGS_COVERAGE "${CMAKE_EXE_LINKER_FLAGS_DEBUG}"
    CACHE STRING "Flags used for linking binaries during coverage builds."
    FORCE)
  set(BENCHMARK_SHARED_LINKER_FLAGS_COVERAGE "${CMAKE_SHARED_LINKER_FLAGS_DEBUG}"
    CACHE STRING "Flags used by the shared libraries linker during coverage builds."
    FORCE)
  mark_as_advanced(
    BENCHMARK_CXX_FLAGS_COVERAGE
    BENCHMARK_EXE_LINKER_FLAGS_COVERAGE
    BENCHMARK_SHARED_LINKER_FLAGS_COVERAGE)
  set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Coverage.")
  add_cxx_compiler_flag(--coverage COVERAGE)
endif()

if (BENCHMARK_USE_LIBCXX)
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_cxx_compiler_flag(-stdlib=libc++)
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
          "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    add_cxx_compiler_flag(-nostdinc++)
    message("libc++ header path must be manually specified using CMAKE_CXX_FLAGS")
    # Adding -nodefaultlibs directly to CMAKE_<TYPE>_LINKER_FLAGS will break
    # configuration checks such as 'find_package(Threads)'
    list(APPEND BENCHMARK_CXX_LINKER_FLAGS -nodefaultlibs)
    # -lc++ cannot be added directly to CMAKE_<TYPE>_LINKER_FLAGS because
    # linker flags appear before all linker inputs and -lc++ must appear after.
    list(APPEND BENCHMARK_CXX_LIBRARIES c++)
  else()
    message(FATAL "-DBENCHMARK_USE_LIBCXX:BOOL=ON is not supported for compiler")
  endif()
endif(BENCHMARK_USE_LIBCXX)

# C++ feature checks
# Determine the correct regular expression engine to use
cxx_feature_check(STD_REGEX)
cxx_feature_check(GNU_POSIX_REGEX)
cxx_feature_check(POSIX_REGEX)
if(NOT HAVE_STD_REGEX AND NOT HAVE_GNU_POSIX_REGEX AND NOT HAVE_POSIX_REGEX)
  message(FATAL_ERROR "Failed to determine the source files for the regular expression backend")
endif()
if (NOT BENCHMARK_ENABLE_EXCEPTIONS AND HAVE_STD_REGEX
        AND NOT HAVE_GNU_POSIX_REGEX AND NOT HAVE_POSIX_REGEX)
  message(WARNING "Using std::regex with exceptions disabled is not fully supported")
endif()
cxx_feature_check(STEADY_CLOCK)
# Ensure we have pthreads
find_package(Threads REQUIRED)

# Set up directories
include_directories(${PROJECT_SOURCE_DIR}/include)

# Build the targets
add_subdirectory(src)

if (BENCHMARK_ENABLE_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

=== src/CMakeLists.txt ===
# Allow the source files to find headers in src/
include_directories(${PROJECT_SOURCE_DIR}/src)

if (DEFINED BENCHMARK_CXX_LINKER_FLAGS)
  list(APPEND CMAKE_SHARED_LINKER_FLAGS ${BENCHMARK_CXX_LINKER_FLAGS})
  list(APPEND CMAKE_MODULE_LINKER_FLAGS ${BENCHMARK_CXX_LINKER_FLAGS})
endif()

file(GLOB
  SOURCE_FILES
    *.cc
    ${PROJECT_SOURCE_DIR}/include/benchmark/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h)

add_library(benchmark ${SOURCE_FILES})
set_target_properties(benchmark PROPERTIES
  OUTPUT_NAME "benchmark"
  VERSION ${GENERIC_LIB_VERSION}
  SOVERSION ${GENERIC_LIB_SOVERSION}
)
target_include_directories(benchmark PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    )

# Link threads.
target_link_libraries(benchmark  ${BENCHMARK_CXX_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
find_library(LIBRT rt)
if(LIBRT)
  target_link_libraries(benchmark ${LIBRT})
endif()

# We need extra libraries on Windows
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  target_link_libraries(benchmark Shlwapi)
endif()

set(include_install_dir "include")
set(lib_install_dir "lib/")
set(bin_install_dir "bin/")
set(config_install_dir "lib/cmake/${PROJECT_NAME}")

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")

set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${version_config}" VERSION ${GIT_VERSION} COMPATIBILITY SameMajorVersion
)

configure_file("${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in" "${project_config}" @ONLY)

if (BENCHMARK_ENABLE_INSTALL)
  # Install target (will install the library to specified CMAKE_INSTALL_PREFIX variable)
  install(
    TARGETS benchmark
    EXPORT ${targets_export_name}
    ARCHIVE DESTINATION ${lib_install_dir}
    LIBRARY DESTINATION ${lib_install_dir}
    RUNTIME DESTINATION ${bin_install_dir}
    INCLUDES DESTINATION ${include_install_dir})
  
  install(
    DIRECTORY "${PROJECT_SOURCE_DIR}/include/benchmark"
    DESTINATION ${include_install_dir}
    FILES_MATCHING PATTERN "*.*h")
  
  install(
      FILES "${project_config}" "${version_config}"
      DESTINATION "${config_install_dir}")
  
  install(
      EXPORT "${targets_export_name}"
      NAMESPACE "${namespace}"
      DESTINATION "${config_install_dir}")
endif()

=== test/CMakeLists.txt ===
# Enable the tests

find_package(Threads REQUIRED)
include(CheckCXXCompilerFlag)

# NOTE: Some tests use `<cassert>` to perform the test. Therefore we must
# strip -DNDEBUG from the default CMake flags in DEBUG mode.
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if( NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "DEBUG" )
  add_definitions( -UNDEBUG )
  add_definitions(-DTEST_BENCHMARK_LIBRARY_HAS_NO_ASSERTIONS)
  # Also remove /D NDEBUG to avoid MSVC warnings about conflicting defines.
  foreach (flags_var_to_scrub
      CMAKE_CXX_FLAGS_RELEASE
      CMAKE_CXX_FLAGS_RELWITHDEBINFO
      CMAKE_CXX_FLAGS_MINSIZEREL
      CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_RELWITHDEBINFO
      CMAKE_C_FLAGS_MINSIZEREL)
    string (REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " "
      "${flags_var_to_scrub}" "${${flags_var_to_scrub}}")
  endforeach()
endif()

# NOTE: These flags must be added after find_package(Threads REQUIRED) otherwise
# they will break the configuration check.
if (DEFINED BENCHMARK_CXX_LINKER_FLAGS)
  list(APPEND CMAKE_EXE_LINKER_FLAGS ${BENCHMARK_CXX_LINKER_FLAGS})
endif()

add_library(output_test_helper STATIC output_test_helper.cc output_test.h)

macro(compile_benchmark_test name)
  add_executable(${name} "${name}.cc")
  target_link_libraries(${name} benchmark ${CMAKE_THREAD_LIBS_INIT})
endmacro(compile_benchmark_test)


macro(compile_output_test name)
  add_executable(${name} "${name}.cc" output_test.h)
  target_link_libraries(${name} output_test_helper benchmark
          ${BENCHMARK_CXX_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
endmacro(compile_output_test)


# Demonstration executable
compile_benchmark_test(benchmark_test)
add_test(benchmark benchmark_test --benchmark_min_time=0.01)

compile_benchmark_test(filter_test)
macro(add_filter_test name filter expect)
  add_test(${name} filter_test --benchmark_min_time=0.01 --benchmark_filter=${filter} ${expect})
  add_test(${name}_list_only filter_test --benchmark_list_tests --benchmark_filter=${filter} ${expect})
endmacro(add_filter_test)

add_filter_test(filter_simple "Foo" 3)
add_filter_test(filter_suffix "BM_.*" 4)
add_filter_test(filter_regex_all ".*" 5)
add_filter_test(filter_regex_blank "" 5)
add_filter_test(filter_regex_none "monkey" 0)
add_filter_test(filter_regex_wildcard ".*Foo.*" 3)
add_filter_test(filter_regex_begin "^BM_.*" 4)
add_filter_test(filter_regex_begin2 "^N" 1)
add_filter_test(filter_regex_end ".*Ba$" 1)

compile_benchmark_test(options_test)
add_test(options_benchmarks options_test --benchmark_min_time=0.01)

compile_benchmark_test(basic_test)
add_test(basic_benchmark basic_test --benchmark_min_time=0.01)

compile_benchmark_test(diagnostics_test)
add_test(diagnostics_test diagnostics_test --benchmark_min_time=0.01)

compile_benchmark_test(skip_with_error_test)
add_test(skip_with_error_test skip_with_error_test --benchmark_min_time=0.01)

compile_benchmark_test(donotoptimize_test)
# Some of the issues with DoNotOptimize only occur when optimization is enabled
check_cxx_compiler_flag(-O3 BENCHMARK_HAS_O3_FLAG)
if (BENCHMARK_HAS_O3_FLAG)
  set_target_properties(donotoptimize_test PROPERTIES COMPILE_FLAGS "-O3")
endif()
add_test(donotoptimize_test donotoptimize_test --benchmark_min_time=0.01)

compile_benchmark_test(fixture_test)
add_test(fixture_test fixture_test --benchmark_min_time=0.01)

compile_benchmark_test(register_benchmark_test)
add_test(register_benchmark_test register_benchmark_test --benchmark_min_time=0.01)

compile_benchmark_test(map_test)
add_test(map_test map_test --benchmark_min_time=0.01)

compile_benchmark_test(multiple_ranges_test)
add_test(multiple_ranges_test multiple_ranges_test --benchmark_min_time=0.01)

compile_output_test(reporter_output_test)
add_test(reporter_output_test reporter_output_test --benchmark_min_time=0.01)

compile_output_test(templated_fixture_test)
add_test(templated_fixture_test templated_fixture_test --benchmark_min_time=0.01)

compile_output_test(user_counters_test)
add_test(user_counters_test user_counters_test --benchmark_min_time=0.01)

compile_output_test(user_counters_tabular_test)
add_test(user_counters_tabular_test user_counters_tabular_test --benchmark_counters_tabular=true --benchmark_min_time=0.01)

check_cxx_compiler_flag(-std=c++03 BENCHMARK_HAS_CXX03_FLAG)
if (BENCHMARK_HAS_CXX03_FLAG)
  compile_benchmark_test(cxx03_test)
  set_target_properties(cxx03_test
      PROPERTIES
      COMPILE_FLAGS "-std=c++03")
  # libstdc++ provides different definitions within <map> between dialects. When
  # LTO is enabled and -Werror is specified GCC diagnoses this ODR violation
  # causing the test to fail to compile. To prevent this we explicitly disable
  # the warning.
  check_cxx_compiler_flag(-Wno-odr BENCHMARK_HAS_WNO_ODR)
  if (BENCHMARK_ENABLE_LTO AND BENCHMARK_HAS_WNO_ODR)
    set_target_properties(cxx03_test
        PROPERTIES
        LINK_FLAGS "-Wno-odr")
  endif()
  add_test(cxx03 cxx03_test --benchmark_min_time=0.01)
endif()

# Attempt to work around flaky test failures when running on Appveyor servers.
if (DEFINED ENV{APPVEYOR})
  set(COMPLEXITY_MIN_TIME "0.5")
else()
  set(COMPLEXITY_MIN_TIME "0.01")
endif()
compile_output_test(complexity_test)
add_test(complexity_benchmark complexity_test --benchmark_min_time=${COMPLEXITY_MIN_TIME})

# Add the coverage command(s)
if(CMAKE_BUILD_TYPE)
  string(TOLOWER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_LOWER)
endif()
if (${CMAKE_BUILD_TYPE_LOWER} MATCHES "coverage")
  find_program(GCOV gcov)
  find_program(LCOV lcov)
  find_program(GENHTML genhtml)
  find_program(CTEST ctest)
  if (GCOV AND LCOV AND GENHTML AND CTEST AND HAVE_CXX_FLAG_COVERAGE)
    add_custom_command(
      OUTPUT ${CMAKE_BINARY_DIR}/lcov/index.html
      COMMAND ${LCOV} -q -z -d .
      COMMAND ${LCOV} -q --no-external -c -b "${CMAKE_SOURCE_DIR}" -d . -o before.lcov -i
      COMMAND ${CTEST} --force-new-ctest-process
      COMMAND ${LCOV} -q --no-external -c -b "${CMAKE_SOURCE_DIR}" -d . -o after.lcov
      COMMAND ${LCOV} -q -a before.lcov -a after.lcov --output-file final.lcov
      COMMAND ${LCOV} -q -r final.lcov "'${CMAKE_SOURCE_DIR}/test/*'" -o final.lcov
      COMMAND ${GENHTML} final.lcov -o lcov --demangle-cpp --sort -p "${CMAKE_BINARY_DIR}" -t benchmark
      DEPENDS filter_test benchmark_test options_test basic_test fixture_test cxx03_test complexity_test
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
      COMMENT "Running LCOV"
    )
    add_custom_target(coverage
      DEPENDS ${CMAKE_BINARY_DIR}/lcov/index.html
      COMMENT "LCOV report at lcov/index.html"
    )
    message(STATUS "Coverage command added")
  else()
    if (HAVE_CXX_FLAG_COVERAGE)
      set(CXX_FLAG_COVERAGE_MESSAGE supported)
    else()
      set(CXX_FLAG_COVERAGE_MESSAGE unavailable)
    endif()
    message(WARNING
      "Coverage not available:\n"
      "  gcov: ${GCOV}\n"
      "  lcov: ${LCOV}\n"
      "  genhtml: ${GENHTML}\n"
      "  ctest: ${CTEST}\n"
      "  --coverage flag: ${CXX_FLAG_COVERAGE_MESSAGE}")
  endif()
endif()

=== debian/changelog ===
benchmark (1.3.0-2) unstable; urgency=medium

  [ Robert Guo ]
  * [c65f0ab] Use STCK to get the CPU clock on s390x. (Closes: #881736)

  [ Anton Gladky ]
  * [3245571] Update d/watch
  * [c64ac86] Use pkg-info.mk for extracting Upstream version
  * [656070d] Set Standards-Version: 4.1.3
  * [3282de0] Apply cme fix dpkg

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Mar 2018 21:10:48 +0100

benchmark (1.3.0-1) unstable; urgency=medium

  * Initial upload. (Closes: #881378)

 -- Anton Gladky <gladk@debian.org>  Sat, 11 Nov 2017 10:21:55 +0100

=== debian/control ===
Source: benchmark
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10)
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/benchmark.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/benchmark.git
Homepage: https://github.com/google/benchmark

Package: libbenchmark-dev
Architecture: any
Section: libdevel
Depends: libbenchmark1 (= ${binary:Version}),
         ${misc:Depends}
Description: Microbenchmark support library, development files
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains the development files.

Package: libbenchmark1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbenchmark-tools
Pre-Depends: ${misc:Pre-Depends}
Description: Microbenchmark support library, shared library
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains the shared library.

Package: libbenchmark-tools
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: python (>> 3)
Pre-Depends: ${misc:Pre-Depends}
Description: Microbenchmark support library, tools and documentation
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains tools and documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DGIT_VERSION="$(DEB_VERSION_UPSTREAM)"

=== debian/tests/control ===
Tests: all
Depends: libbenchmark-dev, build-essential
Restrictions: allow-stderr

## benchmark 1.4.1

=== debian/changelog ===
benchmark (1.4.1-3) unstable; urgency=medium

  [ Anton Gladky ]
  * [d0feebb] Install *.a files. (Closes: #912078)
  * [b64af1c] Fix error in d/copyright. (Closes: #912653)

  [ John David Anglin ]
  * [151eb89] Fix compilation on hppa. (Closes: #910606)

 -- Anton Gladky <gladk@debian.org>  Sun, 18 Nov 2018 00:03:07 +0100

benchmark (1.4.1-2) unstable; urgency=medium

  * [f17dafe] Fix tests for the s390 arch
  * [67da8cd] Disable temporarily two tests, failing on mips

 -- Anton Gladky <gladk@debian.org>  Sun, 21 Oct 2018 13:49:45 +0200

benchmark (1.4.1-1) unstable; urgency=medium

  * [482a6f3] Update VCS-fields
  * [3df809d] Set Standards-Version to 4.2.1
  * [9562e08] Add gmock and gtest as a build-depends
  * [4465821] New upstream version 1.4.1
  * [2d86da7] Refresh patch, remove old one

 -- Anton Gladky <gladk@debian.org>  Mon, 08 Oct 2018 09:55:44 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,12 @@
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10)
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/benchmark.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/benchmark.git
+               debhelper (>= 10),
+               libgmock-dev,
+               libgtest-dev
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/science-team/benchmark
+Vcs-Git: https://salsa.debian.org/science-team/benchmark.git
 Homepage: https://github.com/google/benchmark
 
 Package: libbenchmark-dev

## benchmark 1.5.0

=== debian/changelog ===
benchmark (1.5.0-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:10:41 +0100

benchmark (1.5.0-4) unstable; urgency=medium

  * Cherry-pick RISC-V patch from upstream for riscv64 support.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 28 Nov 2019 17:27:24 +0100

benchmark (1.5.0-3) unstable; urgency=medium

  * Build in release mode so that timings are not affected. (Closes: #941279)
  * Set upstream metadata fields: Repository.
  * libbenchmark-dev: include the README file in
    /usr/share/doc/libbenchmark-dev

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 27 Nov 2019 11:51:49 +0100

benchmark (1.5.0-2) unstable; urgency=medium

  * [262160d] Disable some tests, failing on mipsel

 -- Anton Gladky <gladk@debian.org>  Mon, 23 Sep 2019 21:15:31 +0200

benchmark (1.5.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * [5568a99] New upstream version 1.5.0
  * [8f0e28b] debhelper-compat 12
  * [5d33c05] Standards-Version: 4.4.0
  * [95d65ff] Apply patch from upstream so we can specify the location
              of Debian's googletest source
  * [cf849ee] Set upstream metadata fields: Name.
  * [8f89de1] use Debian's copy of googletest
  * [d02264a] cmake files are now in /usr/lib/*/cmake/benchmar
  * [13b785e] use pkg-config in autopkgtest
  * [4191c2b] libbenchmark-tools is Multi-Arch: foreign
  * [b328ed4] avoid g++-9 bug

  [ Anton Gladky ]
  * [77c8a77] Add Michael as an uploader
  * [a9d43d4] Remove obsolete fields Name from debian/upstream/metadata.

 -- Anton Gladky <gladk@debian.org>  Sun, 22 Sep 2019 22:21:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: benchmark
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Anton Gladky <gladk@debian.org>
+Uploaders: Anton Gladky <gladk@debian.org>, Michael R. Crusoe <michael.crusoe@gmail.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper-compat (= 12),
                libgmock-dev,
-               libgtest-dev
-Standards-Version: 4.2.1
+               googletest
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/science-team/benchmark
 Vcs-Git: https://salsa.debian.org/science-team/benchmark.git
 Homepage: https://github.com/google/benchmark
@@ -35,6 +35,7 @@
  This package contains the shared library.
 
 Package: libbenchmark-tools
+Multi-Arch: foreign
 Architecture: all
 Section: doc
 Depends: ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,6 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DGIT_VERSION="$(DEB_VERSION_UPSTREAM)"
+	dh_auto_configure -- -DGIT_VERSION="$(DEB_VERSION_UPSTREAM)" \
+		-DGOOGLETEST_PATH=/usr/src/googletest \
+		-DCMAKE_BUILD_TYPE=Release -DBENCHMARK_ENABLE_LTO=true

=== debian/tests/control ===
Tests: all
Depends: libbenchmark-dev, build-essential, pkg-config, g++-8
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://github.com/google/benchmark/tags .*/?v(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## benchmark 1.5.1

=== debian/changelog ===
benchmark (1.5.1-1) unstable; urgency=medium

  * [00ce51f] New upstream version 1.5.1
  * [e620882] Refresh patches
  * [0359951] Add --buildsystem=cmake to d/rules
  * [666ae4d] Set upstream metadata fields: Bug-Database, Bug-Submit,
              Repository, Repository-Browse.
  * [5ec0f74] Update standards version to 4.5.0, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Sat, 13 Jun 2020 22:46:45 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                debhelper-compat (= 12),
                libgmock-dev,
                googletest
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/benchmark
 Vcs-Git: https://salsa.debian.org/science-team/benchmark.git
 Homepage: https://github.com/google/benchmark

## benchmark 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,81 @@
-cmake_minimum_required (VERSION 2.8.12)
-
-project (benchmark)
+cmake_minimum_required (VERSION 3.5.1)
 
 foreach(p
+    CMP0048 # OK to clear PROJECT_VERSION on project()
     CMP0054 # CMake 3.1
     CMP0056 # export EXE_LINKER_FLAGS to try_run
+    CMP0057 # Support no if() IN_LIST operator
+    CMP0063 # Honor visibility properties for all targets
+    CMP0077 # Allow option() overrides in importing projects
     )
   if(POLICY ${p})
     cmake_policy(SET ${p} NEW)
   endif()
 endforeach()
+
+project (benchmark CXX)
 
 option(BENCHMARK_ENABLE_TESTING "Enable testing of the benchmark library." ON)
 option(BENCHMARK_ENABLE_EXCEPTIONS "Enable the use of exceptions in the benchmark library." ON)
 option(BENCHMARK_ENABLE_LTO "Enable link time optimisation of the benchmark library." OFF)
 option(BENCHMARK_USE_LIBCXX "Build and test using libc++ as the standard library." OFF)
-option(BENCHMARK_BUILD_32_BITS "Build a 32 bit version of the library." OFF)
+if(NOT MSVC)
+  option(BENCHMARK_BUILD_32_BITS "Build a 32 bit version of the library." OFF)
+else()
+  set(BENCHMARK_BUILD_32_BITS OFF CACHE BOOL "Build a 32 bit version of the library - unsupported when using MSVC)" FORCE)
+endif()
 option(BENCHMARK_ENABLE_INSTALL "Enable installation of benchmark. (Projects embedding benchmark may want to turn this OFF.)" ON)
 
+# Allow unmet dependencies to be met using CMake's ExternalProject mechanics, which
+# may require downloading the source code.
+option(BENCHMARK_DOWNLOAD_DEPENDENCIES "Allow the downloading and in-tree building of unmet dependencies" OFF)
+
+# This option can be used to disable building and running unit tests which depend on gtest
+# in cases where it is not possible to build or find a valid version of gtest.
+option(BENCHMARK_ENABLE_GTEST_TESTS "Enable building the unit tests which depend on gtest" ON)
+
+set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
+set(ENABLE_ASSEMBLY_TESTS_DEFAULT OFF)
+function(should_enable_assembly_tests)
+  if(CMAKE_BUILD_TYPE)
+    string(TOLOWER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_LOWER)
+    if (${CMAKE_BUILD_TYPE_LOWER} MATCHES "coverage")
+      # FIXME: The --coverage flag needs to be removed when building assembly
+      # tests for this to work.
+      return()
+    endif()
+  endif()
+  if (MSVC)
+    return()
+  elseif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
+    return()
+  elseif(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
+    # FIXME: Make these work on 32 bit builds
+    return()
+  elseif(BENCHMARK_BUILD_32_BITS)
+     # FIXME: Make these work on 32 bit builds
+    return()
+  endif()
+  find_program(LLVM_FILECHECK_EXE FileCheck)
+  if (LLVM_FILECHECK_EXE)
+    set(LLVM_FILECHECK_EXE "${LLVM_FILECHECK_EXE}" CACHE PATH "llvm filecheck" FORCE)
+    message(STATUS "LLVM FileCheck Found: ${LLVM_FILECHECK_EXE}")
+  else()
+    message(STATUS "Failed to find LLVM FileCheck")
+    return()
+  endif()
+  set(ENABLE_ASSEMBLY_TESTS_DEFAULT ON PARENT_SCOPE)
+endfunction()
+should_enable_assembly_tests()
+
+# This option disables the building and running of the assembly verification tests
+option(BENCHMARK_ENABLE_ASSEMBLY_TESTS "Enable building and running the assembly tests"
+    ${ENABLE_ASSEMBLY_TESTS_DEFAULT})
+
 # Make sure we can import out CMake functions
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
 
 # Read the git tags to determine the project version
 include(GetGitVersion)
@@ -27,7 +83,7 @@
 
 # Tell the user what versions we are using
 string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" VERSION ${GIT_VERSION})
-message("-- Version: ${VERSION}")
+message(STATUS "Version: ${VERSION}")
 
 # The version of the libraries
 set(GENERIC_LIB_VERSION ${VERSION})
@@ -42,7 +98,7 @@
   add_required_cxx_compiler_flag(-m32)
 endif()
 
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
+if (MSVC)
   # Turn compiler warnings up to 11
   string(REGEX REPLACE "[-/]W[1-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
@@ -51,6 +107,7 @@
   if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
     add_cxx_compiler_flag(-EHs-)
     add_cxx_compiler_flag(-EHa-)
+    add_definitions(-D_HAS_EXCEPTIONS=0)
   endif()
   # Link time optimisation
   if (BENCHMARK_ENABLE_LTO)
@@ -82,23 +139,33 @@
 
   # Turn compiler warnings up to 11
   add_cxx_compiler_flag(-Wall)
-
   add_cxx_compiler_flag(-Wextra)
   add_cxx_compiler_flag(-Wshadow)
   add_cxx_compiler_flag(-Werror RELEASE)
   add_cxx_compiler_flag(-Werror RELWITHDEBINFO)
   add_cxx_compiler_flag(-Werror MINSIZEREL)
-  add_cxx_compiler_flag(-pedantic)
-  add_cxx_compiler_flag(-pedantic-errors)
+  # Disabled until googletest (gmock) stops emitting variadic macro warnings
+  #add_cxx_compiler_flag(-pedantic)
+  #add_cxx_compiler_flag(-pedantic-errors)
   add_cxx_compiler_flag(-Wshorten-64-to-32)
-  add_cxx_compiler_flag(-Wfloat-equal)
   add_cxx_compiler_flag(-fstrict-aliasing)
+  # Disable warnings regarding deprecated parts of the library while building
+  # and testing those parts of the library.
+  add_cxx_compiler_flag(-Wno-deprecated-declarations)
+  if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
+    # Intel silently ignores '-Wno-deprecated-declarations',
+    # warning no. 1786 must be explicitly disabled.
+    # See #631 for rationale.
+    add_cxx_compiler_flag(-wd1786)
+  endif()
+  # Disable deprecation warnings for release builds (when -Werror is enabled).
+  add_cxx_compiler_flag(-Wno-deprecated RELEASE)
+  add_cxx_compiler_flag(-Wno-deprecated RELWITHDEBINFO)
+  add_cxx_compiler_flag(-Wno-deprecated MINSIZEREL)
   if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
     add_cxx_compiler_flag(-fno-exceptions)
   endif()
-  if (NOT BENCHMARK_USE_LIBCXX)
-    add_cxx_compiler_flag(-Wzero-as-null-pointer-constant)
-  endif()
+
   if (HAVE_CXX_FLAG_FSTRICT_ALIASING)
     if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel") #ICC17u2: Many false positives for Wstrict-aliasing
       add_cxx_compiler_flag(-Wstrict-aliasing)
@@ -106,7 +173,7 @@
   endif()
   # ICC17u2: overloaded virtual function "benchmark::Fixture::SetUp" is only partially overridden
   # (because of deprecated overload)
-  add_cxx_compiler_flag(-wd654)  
+  add_cxx_compiler_flag(-wd654)
   add_cxx_compiler_flag(-Wthread-safety)
   if (HAVE_CXX_FLAG_WTHREAD_SAFETY)
     cxx_feature_check(THREAD_SAFETY_ATTRIBUTES)
@@ -120,10 +187,14 @@
     add_definitions(-D_GNU_SOURCE=1)
   endif()
 
+  if (QNXNTO)
+    add_definitions(-D_QNX_SOURCE)
+  endif()
+
   # Link time optimisation
   if (BENCHMARK_ENABLE_LTO)
     add_cxx_compiler_flag(-flto)
-    if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
+    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
       find_program(GCC_AR gcc-ar)
       if (GCC_AR)
         set(CMAKE_AR ${GCC_AR})
@@ -132,6 +203,8 @@
       if (GCC_RANLIB)
         set(CMAKE_RANLIB ${GCC_RANLIB})
       endif()
+    elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
+      include(llvm-toolchain)
     endif()
   endif()
 
@@ -155,12 +228,12 @@
 endif()
 
 if (BENCHMARK_USE_LIBCXX)
-  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
     add_cxx_compiler_flag(-stdlib=libc++)
   elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
           "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
     add_cxx_compiler_flag(-nostdinc++)
-    message("libc++ header path must be manually specified using CMAKE_CXX_FLAGS")
+    message(WARNING "libc++ header path must be manually specified using CMAKE_CXX_FLAGS")
     # Adding -nodefaultlibs directly to CMAKE_<TYPE>_LINKER_FLAGS will break
     # configuration checks such as 'find_package(Threads)'
     list(APPEND BENCHMARK_CXX_LINKER_FLAGS -nodefaultlibs)
@@ -168,15 +241,21 @@
     # linker flags appear before all linker inputs and -lc++ must appear after.
     list(APPEND BENCHMARK_CXX_LIBRARIES c++)
   else()
-    message(FATAL "-DBENCHMARK_USE_LIBCXX:BOOL=ON is not supported for compiler")
+    message(FATAL_ERROR "-DBENCHMARK_USE_LIBCXX:BOOL=ON is not supported for compiler")
   endif()
 endif(BENCHMARK_USE_LIBCXX)
+
+set(EXTRA_CXX_FLAGS "")
+if (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
+  # Clang on Windows fails to compile the regex feature check under C++11
+  set(EXTRA_CXX_FLAGS "-DCMAKE_CXX_STANDARD=14")
+endif()
 
 # C++ feature checks
 # Determine the correct regular expression engine to use
-cxx_feature_check(STD_REGEX)
-cxx_feature_check(GNU_POSIX_REGEX)
-cxx_feature_check(POSIX_REGEX)
+cxx_feature_check(STD_REGEX ${EXTRA_CXX_FLAGS})
+cxx_feature_check(GNU_POSIX_REGEX ${EXTRA_CXX_FLAGS})
+cxx_feature_check(POSIX_REGEX ${EXTRA_CXX_FLAGS})
 if(NOT HAVE_STD_REGEX AND NOT HAVE_GNU_POSIX_REGEX AND NOT HAVE_POSIX_REGEX)
   message(FATAL_ERROR "Failed to determine the source files for the regular expression backend")
 endif()
@@ -184,8 +263,10 @@
         AND NOT HAVE_GNU_POSIX_REGEX AND NOT HAVE_POSIX_REGEX)
   message(WARNING "Using std::regex with exceptions disabled is not fully supported")
 endif()
+
 cxx_feature_check(STEADY_CLOCK)
 # Ensure we have pthreads
+set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads REQUIRED)
 
 # Set up directories
@@ -196,5 +277,10 @@
 
 if (BENCHMARK_ENABLE_TESTING)
   enable_testing()
+  if (BENCHMARK_ENABLE_GTEST_TESTS AND
+      NOT (TARGET gtest AND TARGET gtest_main AND
+           TARGET gmock AND TARGET gmock_main))
+    include(GoogleTest)
+  endif()
   add_subdirectory(test)
 endif()

=== conan/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(cmake_wrapper)

include(conanbuildinfo.cmake)
conan_basic_setup()

include(${CMAKE_SOURCE_DIR}/CMakeListsOriginal.txt)

=== debian/changelog ===
benchmark (1.5.2-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/fix-missing-symbols-in-static.patch:
    Work around -flto bug, fix courtesy Kentaro Hayashi
    Closes: #968461
  * Mark libbenchmark-dev as Multi-Arch: same as per the Multiarch
    hinter.
  * Standards-Version: 4.5.1 (routine-update)
  * Modernize debian/watch.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 23 Nov 2020 10:40:57 +0100

benchmark (1.5.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 10 Oct 2020 18:09:32 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,18 @@
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libgmock-dev,
                googletest
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/benchmark
 Vcs-Git: https://salsa.debian.org/science-team/benchmark.git
 Homepage: https://github.com/google/benchmark
+Rules-Requires-Root: no
 
 Package: libbenchmark-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libbenchmark1 (= ${binary:Version}),
          ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DGIT_VERSION="$(DEB_VERSION_UPSTREAM)" \

=== debian/tests/control ===
Tests: all static
Depends: libbenchmark-dev, build-essential, pkg-config, g++-8
Restrictions: allow-stderr
